package cn.com.qmth.stmms.admin.dto;

import java.math.BigDecimal;
import java.math.RoundingMode;

import cn.com.qmth.stmms.biz.report.model.ReportSubject;
import cn.com.qmth.stmms.common.annotation.ExcelField;

/**
 * 课程总量分析
 *
 */
public class ReportSubjectDTO {

    /**
     * 课程编号
     */
    @ExcelField(title = "课程代码", align = 2, sort = 10)
    private String subjectCode;

    /**
     * 课程名称
     */
    @ExcelField(title = "课程名称", align = 2, sort = 20)
    private String subjectName;

    /**
     * 最高分
     */
    @ExcelField(title = "最高分", align = 2, sort = 30)
    private String maxScore;

    /**
     * 最低分
     */
    @ExcelField(title = "最低分", align = 2, sort = 40)
    private String minScore;

    /**
     * 平均分
     */
    @ExcelField(title = "平均分", align = 2, sort = 50)
    private String avgScore;

    /**
     * 报考人数
     */
    @ExcelField(title = "报考人数", align = 2, sort = 60)
    private Integer totalCount;

    /**
     * 及格人数
     */
    @ExcelField(title = "及格人数", align = 2, sort = 70)
    private Integer passCount;

    /**
     * 及格率
     */
    @ExcelField(title = "及格率(%)", align = 2, sort = 80)
    private String passRate;

    /**
     * 优秀率
     */
    @ExcelField(title = "优秀率(%)", align = 2, sort = 90)
    private String excellentRate;

    /**
     * 优秀人数
     */
    @ExcelField(title = "优秀人数", align = 2, sort = 100)
    private Integer excellentCount;

    /**
     * 缺考人数
     */
    @ExcelField(title = "缺考人数", align = 2, sort = 110)
    private Integer absentCount;

    /**
     * 违纪人数
     */
    @ExcelField(title = "违纪人数", align = 2, sort = 120)
    private Integer breachCount;

    /**
     * 有效人数
     */
    @ExcelField(title = "有效人数", align = 2, sort = 130)
    private Integer realityCount;

    public ReportSubjectDTO(ReportSubject r) {
        this.subjectCode = r.getSubjectCode();
        this.subjectName = r.getSubjectName();
        this.maxScore = new BigDecimal(r.getMaxScore()).setScale(2, RoundingMode.HALF_UP).toString();
        this.minScore = new BigDecimal(r.getMinScore()).setScale(2, RoundingMode.HALF_UP).toString();
        this.avgScore = new BigDecimal(r.getAvgScore()).setScale(2, RoundingMode.HALF_UP).toString();
        this.passRate = new BigDecimal(r.getPassRate()).setScale(2, RoundingMode.HALF_UP).toString();
        this.excellentRate = new BigDecimal(r.getExcellentRate()).setScale(2, RoundingMode.HALF_UP).toString();
        this.passCount = r.getPassCount();
        this.excellentCount = r.getExcellentCount();
        this.realityCount = r.getRealityCount();
        this.absentCount = r.getAbsentCount();
        this.breachCount = r.getBreachCount();
        this.totalCount = r.getTotalCount();
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public String getMaxScore() {
        return maxScore;
    }

    public void setMaxScore(String maxScore) {
        this.maxScore = maxScore;
    }

    public String getMinScore() {
        return minScore;
    }

    public void setMinScore(String minScore) {
        this.minScore = minScore;
    }

    public String getAvgScore() {
        return avgScore;
    }

    public void setAvgScore(String avgScore) {
        this.avgScore = avgScore;
    }

    public Integer getTotalCount() {
        return totalCount;
    }

    public void setTotalCount(Integer totalCount) {
        this.totalCount = totalCount;
    }

    public Integer getPassCount() {
        return passCount;
    }

    public void setPassCount(Integer passCount) {
        this.passCount = passCount;
    }

    public String getPassRate() {
        return passRate;
    }

    public void setPassRate(String passRate) {
        this.passRate = passRate;
    }

    public String getExcellentRate() {
        return excellentRate;
    }

    public void setExcellentRate(String excellentRate) {
        this.excellentRate = excellentRate;
    }

    public Integer getExcellentCount() {
        return excellentCount;
    }

    public void setExcellentCount(Integer excellentCount) {
        this.excellentCount = excellentCount;
    }

    public Integer getAbsentCount() {
        return absentCount;
    }

    public void setAbsentCount(Integer absentCount) {
        this.absentCount = absentCount;
    }

    public Integer getBreachCount() {
        return breachCount;
    }

    public void setBreachCount(Integer breachCount) {
        this.breachCount = breachCount;
    }

    public Integer getRealityCount() {
        return realityCount;
    }

    public void setRealityCount(Integer realityCount) {
        this.realityCount = realityCount;
    }
}