package cn.com.qmth.stmms.admin.dto;

import java.math.BigDecimal;
import java.math.RoundingMode;

import cn.com.qmth.stmms.biz.report.model.ReportSubjectGroup;
import cn.com.qmth.stmms.common.annotation.ExcelField;

/**
 * 大题维度分析
 */
public class ReportSubjectGroupDTO {

    /**
     * 课程编号
     */
    @ExcelField(title = "课程代码", align = 2, sort = 10)
    private String subjectCode;

    /**
     * 课程名称
     */
    @ExcelField(title = "课程名称", align = 2, sort = 20)
    private String subjectName;

    /**
     * 大题型
     */
    @ExcelField(title = "大题名称", align = 2, sort = 30)
    private String groupName;

    /**
     * 大题号
     */
    @ExcelField(title = "大题号", align = 2, sort = 40)
    private Integer groupNumber;

    /**
     * 最高分
     */
    @ExcelField(title = "最高分", align = 2, sort = 50)
    private String maxScore;

    /**
     * 最低分
     */
    @ExcelField(title = "最低分", align = 2, sort = 60)
    private String minScore;

    /**
     * 平均分
     */
    @ExcelField(title = "平均分", align = 2, sort = 70)
    private String avgScore;

    /**
     * 满分
     */
    @ExcelField(title = "满分", align = 2, sort = 80)
    private String totalScore;

    /**
     * 标准差
     */
    @ExcelField(title = "标准差", align = 2, sort = 90)
    private String stdev;

    /**
     * 差异系数
     */
    @ExcelField(title = "差异系数(%)", align = 2, sort = 100)
    private String coefficient;

    /**
     * 得分率
     */
    @ExcelField(title = "得分率", align = 2, sort = 110)
    private String scoreRate;

    /**
     * 零分人数
     */
    @ExcelField(title = "零分人数", align = 2, sort = 120)
    private Integer zeroCount;

    /**
     * 满分人数
     */
    @ExcelField(title = "满分人数", align = 2, sort = 130)
    private Integer fullCount;

    public ReportSubjectGroupDTO(ReportSubjectGroup r) {
        this.subjectCode = r.getSubjectCode();
        this.subjectName = r.getSubjectName();
        this.groupName = r.getGroupName();
        this.groupNumber = r.getGroupNumber();
        this.maxScore = new BigDecimal(r.getMaxScore()).setScale(2, RoundingMode.HALF_UP).toString();
        this.minScore = new BigDecimal(r.getMinScore()).setScale(2, RoundingMode.HALF_UP).toString();
        this.avgScore = new BigDecimal(r.getAvgScore()).setScale(2, RoundingMode.HALF_UP).toString();
        this.totalScore = new BigDecimal(r.getTotalScore()).setScale(2, RoundingMode.HALF_UP).toString();
        this.scoreRate = new BigDecimal(r.getScoreRate()).setScale(2, RoundingMode.HALF_UP).toString();
        this.stdev = new BigDecimal(r.getStdev()).setScale(2, RoundingMode.HALF_UP).toString();
        this.coefficient = new BigDecimal(r.getCoefficient()).setScale(2, RoundingMode.HALF_UP).toString();
        this.zeroCount = r.getZeroCount();
        this.fullCount = r.getFullCount();
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public String getGroupName() {
        return groupName;
    }

    public void setGroupName(String groupName) {
        this.groupName = groupName;
    }

    public Integer getGroupNumber() {
        return groupNumber;
    }

    public void setGroupNumber(Integer groupNumber) {
        this.groupNumber = groupNumber;
    }

    public String getMaxScore() {
        return maxScore;
    }

    public void setMaxScore(String maxScore) {
        this.maxScore = maxScore;
    }

    public String getMinScore() {
        return minScore;
    }

    public void setMinScore(String minScore) {
        this.minScore = minScore;
    }

    public String getAvgScore() {
        return avgScore;
    }

    public void setAvgScore(String avgScore) {
        this.avgScore = avgScore;
    }

    public String getTotalScore() {
        return totalScore;
    }

    public void setTotalScore(String totalScore) {
        this.totalScore = totalScore;
    }

    public String getStdev() {
        return stdev;
    }

    public void setStdev(String stdev) {
        this.stdev = stdev;
    }

    public String getCoefficient() {
        return coefficient;
    }

    public void setCoefficient(String coefficient) {
        this.coefficient = coefficient;
    }

    public String getScoreRate() {
        return scoreRate;
    }

    public void setScoreRate(String scoreRate) {
        this.scoreRate = scoreRate;
    }

    public Integer getZeroCount() {
        return zeroCount;
    }

    public void setZeroCount(Integer zeroCount) {
        this.zeroCount = zeroCount;
    }

    public Integer getFullCount() {
        return fullCount;
    }

    public void setFullCount(Integer fullCount) {
        this.fullCount = fullCount;
    }
}