package cn.com.qmth.stmms.admin.dto;

import java.math.BigDecimal;
import java.math.RoundingMode;

import cn.com.qmth.stmms.biz.report.model.ReportSubjectQuestion;
import cn.com.qmth.stmms.common.annotation.ExcelField;

/**
 * 客观 主观题 成绩分析
 *
 */
public class ReportSubjectQuestionDTO {

    /**
     * 课程编号
     */
    @ExcelField(title = "课程代码", align = 2, sort = 10)
    private String subjectCode;

    /**
     * 课程名称
     */
    @ExcelField(title = "课程名称", align = 2, sort = 20)
    private String subjectName;

    /**
     * 题目名称
     */
    @ExcelField(title = "题目名称", align = 2, sort = 30)
    private String questionName;

    /**
     * 大题号
     */
    @ExcelField(title = "大题号", align = 2, sort = 40)
    private Integer mainNumber;

    /**
     * 小题号
     */
    @ExcelField(title = "小题号", align = 2, sort = 50)
    private String subNumber;

    /**
     * 总分
     */
    @ExcelField(title = "总分", align = 2, sort = 60)
    private String totalScore;

    /**
     * 平均分
     */
    @ExcelField(title = "平均分", align = 2, sort = 70)
    private String avgScore;

    /**
     * 标准差
     */
    @ExcelField(title = "标准差", align = 2, sort = 80)
    private String stdev;

    /**
     * 得分率
     */
    @ExcelField(title = "得分率", align = 2, sort = 90)
    private String scoreRate;

    /**
     * 满分率
     */
    @ExcelField(title = "满分率", align = 2, sort = 100)
    private String fullScoreRate;

    /**
     * 卷型
     */
    @ExcelField(title = "卷型", align = 2, sort = 110)
    private String paperType;

    public ReportSubjectQuestionDTO(ReportSubjectQuestion r) {
        this.subjectCode = r.getSubjectCode();
        this.subjectName = r.getSubjectName();
        this.questionName = r.getQuestionName();
        this.mainNumber = r.getMainNumber();
        this.subNumber = r.getSubNumber();
        this.totalScore = new BigDecimal(r.getTotalScore()).setScale(2, RoundingMode.HALF_UP).toString();
        this.stdev = new BigDecimal(r.getStdev()).setScale(2, RoundingMode.HALF_UP).toString();
        this.scoreRate = new BigDecimal(r.getScoreRate()).setScale(2, RoundingMode.HALF_UP).toString();
        this.fullScoreRate = new BigDecimal(r.getFullScoreRate()).setScale(2, RoundingMode.HALF_UP).toString();
        this.avgScore = new BigDecimal(r.getAvgScore()).setScale(2, RoundingMode.HALF_UP).toString();
        this.paperType = r.getPaperType();
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public String getQuestionName() {
        return questionName;
    }

    public void setQuestionName(String questionName) {
        this.questionName = questionName;
    }

    public Integer getMainNumber() {
        return mainNumber;
    }

    public void setMainNumber(Integer mainNumber) {
        this.mainNumber = mainNumber;
    }

    public String getSubNumber() {
        return subNumber;
    }

    public void setSubNumber(String subNumber) {
        this.subNumber = subNumber;
    }

    public String getTotalScore() {
        return totalScore;
    }

    public void setTotalScore(String totalScore) {
        this.totalScore = totalScore;
    }

    public String getAvgScore() {
        return avgScore;
    }

    public void setAvgScore(String avgScore) {
        this.avgScore = avgScore;
    }

    public String getStdev() {
        return stdev;
    }

    public void setStdev(String stdev) {
        this.stdev = stdev;
    }

    public String getScoreRate() {
        return scoreRate;
    }

    public void setScoreRate(String scoreRate) {
        this.scoreRate = scoreRate;
    }

    public String getFullScoreRate() {
        return fullScoreRate;
    }

    public void setFullScoreRate(String fullScoreRate) {
        this.fullScoreRate = fullScoreRate;
    }

    public String getPaperType() {
        return paperType;
    }

    public void setPaperType(String paperType) {
        this.paperType = paperType;
    }
}